=== pyvast/requirements.txt ===
aiounittest>=1.3
