=== tools/CMakeLists.txt ===
add_subdirectory(dscat)
add_subdirectory(lsvast)
add_subdirectory(zeek-to-vast)
