=== debian/changelog ===
vast (2021.02.24-1) unstable; urgency=medium

  * Upload to unstable.

 -- Sascha Steinbiss <satta@debian.org>  Wed, 24 Feb 2021 13:46:17 +0100

vast (2021.02.24-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Sascha Steinbiss <satta@debian.org>  Wed, 24 Feb 2021 10:10:12 +0100

vast (2021.01.28-2) unstable; urgency=medium

  * Update default configuration to include new config items added in the
    latest upstream version.
  * Update verbosity parameter syntax in autopkgtest.

 -- Sascha Steinbiss <satta@debian.org>  Tue, 02 Feb 2021 10:18:23 +0100

vast (2021.01.28-1) unstable; urgency=medium

  * New upstream release.
  * Refresh and remove patches applied upstream.
  * Add new build-dep on libsimdjson-dev.
  * Adjust lintian override.

 -- Sascha Steinbiss <satta@debian.org>  Thu, 28 Jan 2021 15:58:21 +0100

vast (2020.12.16-5) unstable; urgency=medium

  * Restrict autopkgtests to known working amd64.
  * Build but do not test on other archs.

 -- Sascha Steinbiss <satta@debian.org>  Wed, 27 Jan 2021 01:40:00 +0100

vast (2020.12.16-4) unstable; urgency=medium

  * Restrict archs to amd64.
    Discussions with upstream have suggested that support for other archs is
    not in focus at the moment.
  * Bump Standards-Version,

 -- Sascha Steinbiss <satta@debian.org>  Mon, 11 Jan 2021 15:57:08 +0100

vast (2020.12.16-3) unstable; urgency=medium

  * Use patch from upstream removing SSE2 dependent code completely.
  * Add patch to sort lists of source files to improve reproducibility.
  * Remove obsolete B-D to dh-exec.
  * Remove SIMDe support.
  * Add debugging output to autopkgtest.
  * Limit to 64-bit archs for now.

 -- Sascha Steinbiss <satta@debian.org>  Sun, 10 Jan 2021 13:21:30 +0100

vast (2020.12.16-2) unstable; urgency=medium

  * Try to fix FTBFS on non-amd64 archs using SIMDe.
  * Add -fsigned-char to CFLAGS for archs with unsigned char.
  * Use debhelper for configure and build.

 -- Sascha Steinbiss <satta@debian.org>  Sat, 09 Jan 2021 15:19:06 +0100

vast (2020.12.16-1) unstable; urgency=medium

  * Initial packaging (Closes: #970505)

 -- Sascha Steinbiss <satta@debian.org>  Thu, 17 Dec 2020 17:22:04 +0100
