=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
include /usr/share/dpkg/pkg-info.mk

export DEB_CFLAGS_MAINT_APPEND+=-fsigned-char
export DEB_CXXFLAGS_MAINT_APPEND+=-fsigned-char
export DESTDIR=$(CURDIR)/debian/tmp

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_VERBOSE_MAKEFILE:BOOL=ON \
	-DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
	-DVAST_ENABLE_UNIT_TESTS:BOOL=OFF \
	-DVAST_ENABLE_RELOCATABLE_INSTALLATIONS:BOOL=OFF \
	-DVAST_DATADIR:PATH=/usr/share \
	-DVAST_ENABLE_ZEEK_TO_VAST:BOOL=OFF \
	-DVAST_ENABLE_BUNDLED_CAF:BOOL=OFF \
	-DVAST_ENABLE_ARROW:BOOL=OFF \
	-DVAST_ENABLE_JEMALLOC:BOOL=ON \
	-DVAST_ENABLE_LSVAST:BOOL=ON \
	-DCMAKE_INSTALL_SYSCONFDIR:PATH=/etc \
	-DCMAKE_FIND_PACKAGE_PREFER_CONFIG=ON \
	-DCMAKE_SKIP_INSTALL_RPATH=ON

override_dh_auto_clean:
	dh_auto_clean
	rm -f debian/mansrc/*.1

override_dh_auto_install:
	dh_auto_install --destdir=$(DESTDIR)

override_dh_auto_build:
	dh_auto_build
	asciidoctor -a docdate='' -b manpage debian/mansrc/*adoc

override_dh_missing:
	dh_missing --list-missing

override_dh_dwz:
	# not productive since dwz cannot optimize
