=== debian/tests/control ===
Tests: test-run
Architecture: amd64
Depends: @
Restrictions: needs-root, isolation-container, allow-stderr
