=== debian/watch ===
version=4
https://github.com/tenzir/vast/tags .*/([0-9.]+)\.tar\.gz
